

   MEMBER('screentcvt.clw')                                ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('ONTOP.INC'),ONCE

                     MAP
                       INCLUDE('SCREE001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE                                             ! Generated from procedure template - Window

LOC:NumX             DECIMAL(7,2,1.2)                      !
LOC:NumY             DECIMAL(7,2,1)                        !
LOC:StringBuffer     STRING(200000)                        !
LOC:StayOnTopBtn    BYTE(1)
Stay                &StayOnTop
Window               WINDOW('Scale Window source code'),AT(,,200,54),FONT('Verdana',8,,FONT:regular),ALRT(EscKey),WALLPAPER('backgr.jpg'),TILED,GRAY,DOUBLE
                       PANEL,AT(3,2,139,22),USE(?Panel1),BEVEL(-1,1)
                       PROMPT('Add to &X:'),AT(5,9),USE(?LOC:Num:Prompt),TRN
                       ENTRY(@n-9),AT(38,7,31,12),USE(LOC:NumX),RIGHT(1)
                       PROMPT('Add to &Y:'),AT(72,9),USE(?LOC:Num:Prompt:2),TRN
                       ENTRY(@n-9),AT(104,7,31,12),USE(LOC:NumY),RIGHT(1)
                       BUTTON('C&onvert'),AT(145,2,53,14),USE(?OkButton),FLAT,LEFT,ICON('PanelMode.ico'),DEFAULT
                       BUTTON('&Close'),AT(145,18,53,14),USE(?CancelButton),FLAT,LEFT,ICON('Cancel.ICO')
                       CHECK('&StayOnTop'),AT(3,26),USE(LOC:StayOnTopBtn),TRN,MSG('Stay on Top'),TIP('Stay on Top')
                       PANEL,AT(3,37,194,15),USE(?Panel2),BEVEL(1,-1)
                       STRING('mixer@seal-soft.com'),AT(9,40,184,10),USE(?String1),TRN,CENTER,FONT(,,COLOR:Blue,FONT:underline,CHARSET:ANSI)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
            MAP
ConvertScr        PROCEDURE
GetNumbers        PROCEDURE(*STRING Param1, *LONG N1, *LONG N2, *LONG N3, *LONG N4)
            END
ParseMemo    &ParseMemoClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
CreateILControls    ROUTINE                !Create HyperLink Regions
   CREATE(100, CREATE:Region , )
   100{PROP:Imm   } = TRUE
   100{PROP:Use   } = 100
   100{PROP:Height} = ?String1{PROP:Height}
   100{PROP:Width } = ?String1{PROP:Width }
   100{PROP:XPos  } = ?String1{Prop:XPos  }
   100{PROP:YPos  } = ?String1{Prop:YPos  }
   100{PROP:Hide  } = FALSE
   100{PROP:Cursor} = '~hand.cur'

InternetLinkEvents     Routine                !Handle HyperLink Events
 IF FIELD()=100 AND Event()=Event:MouseUp
   URLHandler(Window{prop:handle},'mailto:stefanenko@dci.dalcominfo.ru')
   EXIT
 END

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IniMgr.Fetch('Setup','LOC:NumX', LOC:NumX)
  IniMgr.Fetch('Setup','LOC:NumY', LOC:NumY)
  SELF.Open(Window)                                        ! Open window
  ParseMemo  &= NEW(ParseMemoClass)
  Do DefineListboxStyle
  Stay &= NEW(StayOnTop)
  IniMgr.Fetch('Main','StayOnTop',LOC:StayOnTopBtn)
  DO CreateILControls
  INIMgr.Fetch('Main',Window)                              ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  DISPOSE(ParseMemo)
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',Window)                           ! Save window data to non-volatile store
  END
  IniMgr.Update('Setup','LOC:NumX', LOC:NumX)
  IniMgr.Update('Setup','LOC:NumY', LOC:NumY)
  IniMgr.Update('Main','StayOnTop', LOC:StayOnTopBtn)
  Stay.Kill
  DISPOSE(Stay)
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?OkButton
      ConvertScr
    OF ?CancelButton
       POST(Event:CloseWindow)
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LOC:StayOnTopBtn
      Stay.SetOnTop(TARGET{PROP:Handle},LOC:StayOnTopBtn)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    DO InternetLinkEvents
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF EscKey
        SETKEYCODE(0)
        CYCLE
      END
    OF EVENT:OpenWindow
      Stay.Init(TARGET{PROP:Handle},LOC:StayOnTopBtn)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

ConvertScr        PROCEDURE
LOC:Line          STRING(2048)
LOC:Line1         STRING(2048)
LOC:Line2         STRING(2048)
LOC:N1            LONG
LOC:N2            LONG
LOC:N3            LONG
LOC:N4            LONG
LOC:Pos           LONG
LOC:Pos1          LONG
LOC:F             BYTE(0)
LOC:Z             BYTE(0)
LOC:Str           STRING(200)
  CODE
  SETCURSOR(CURSOR:Wait)
  LOC:StringBuffer = CLIPBOARD(1)
  ParseMemo.SetMemo(LOC:StringBuffer)
  LOC:StringBuffer = ''
  LOOP
    ParseMemo.Next()
    IF ParseMemo.Eof() THEN BREAK END
    LOC:Line = ParseMemo.GetField()
    LOC:Pos = INSTRING(',AT(', LOC:Line, 1, 1)
    IF LOC:Pos
      LOC:Pos1  = INSTRING(')', LOC:Line, 1, LOC:Pos)+1
      LOC:Line1 = SUB(LOC:Line, 1, LOC:Pos - 1)
      LOC:Line2 = SUB(LOC:Line, LOC:Pos1, 2048)
      LOC:Str = SUB(LOC:Line, LOC:Pos+4, LOC:Pos1 - LOC:Pos-5)
      GetNumbers(LOC:Str, LOC:N1, LOC:N2, LOC:N3, LOC:N4)
      !MESSAGE(CLIP(LOC:Str) & '<13,10>' & LOC:N1 & '-' & LOC:N2 & '-' & LOC:N3 & '-' & LOC:N4)
      LOC:F = TRUE
    ELSE
      LOC:F = FALSE
    END
    IF LOC:F
      IF SUB(LEFT(LOC:Line),1,4) = 'LINE'
        LOC:Line = CLIP(LOC:Line1) & ',AT(' & |
        CLIP(FORMAT(LOC:N1, @N4)) & ',' &|
        CLIP(FORMAT(LOC:N2, @N4)) & ',' &|
        CLIP(FORMAT(LOC:N3, @N4)) & ',' &|
        CLIP(FORMAT(LOC:N4, @N4)) &|
        ')' & CLIP(LOC:Line2)
      ELSE
        LOC:Line = CLIP(LOC:Line1) & ',AT(' & |
        CLIP(FORMAT(LOC:N1, @N4)) & ',' &|
        CLIP(FORMAT(LOC:N2, @N4)) & ',' &|
        CLIP(FORMAT(LOC:N3, @N4b)) & ',' &|
        CLIP(FORMAT(LOC:N4, @N4b)) &|
        ')' & CLIP(LOC:Line2)
      END
    END
    IF LOC:Z
      LOC:StringBuffer = CLIP(LOC:Line)
    ELSE
      LOC:StringBuffer = CLIP(LOC:StringBuffer) & '<13,10>' & CLIP(LOC:Line)
    END
  END
  SETCLIPBOARD(LOC:StringBuffer)
  SETCURSOR(CURSOR:Arrow)
GetNumbers        PROCEDURE(*STRING Param1, *LONG N1, *LONG N2, *LONG N3, *LONG N4)
LOC:Char          STRING(1)
LOC:Cur           BYTE(0)
  CODE
  N1 = 0
  N2 = 0
  N3 = 0
  N4 = 0
  LOOP W# = 1 TO LenStr(Param1)
    LOC:Char = SUB(Param1, W#, 1)
    IF LOC:Char = ',' OR W# = LenStr(Param1)
      LOC:Cur += 1
      !  1
      IF LOC:Cur = 1 AND W# = 1        !  1 
        N1 = 0
        S# = 2
      ELSIF LOC:Cur = 1 AND W# > 1     !  1 
        N1 = SUB(Param1, 1, W#-1)
        S# = W#+1
      END
      !  2
      IF LOC:Cur = 2 AND W# = S#       !  2 
        N2 = 0
        S# = W#+1
      ELSIF LOC:Cur = 2 AND W# > S#     !  2 
        N2 = SUB(Param1, S#, W#-1)
        S# = W#+1
      END
      !  3
      IF LOC:Cur = 3 AND W# = S#       !  3 
        N3 = 0
        S# = W#+1
      ELSIF LOC:Cur = 3 AND W# > S#     !  3 
        N3 = SUB(Param1, S#, W#-1)
        S# = W#+1
      END
      !  4
      IF LOC:Cur = 4 AND W# = S#
        N4 = SUB(Param1, S#, W#+1)
        S# = W#+1
      ELSIF LOC:Cur = 4 AND W# > S#     !  4 
        N4 = SUB(Param1, S#, W#)
        S# = W#+1
      END
    END
  END
  !MESSAGE('-----------<13,10>' & CLIP(Param1) & '<13,10>' & N1 & '-' & N2 & '-' & N3 & '-' & N4)
  IF N1
    N1 = ABS(N1 + LOC:NumX)
  END
  IF N2
    N2 = ABS(N2 + LOC:NumY)
  END
  IF N3
    N3 = ABS(N3)
  END
  IF N4
    N4 = ABS(N4)
  END
